## ufc 1.4.1

=== SConstruct ===
# -*- coding: utf-8 -*-
import os, sys, glob, re
from os.path     import join, isfile, isdir, getsize, sep, normpath, dirname, basename
from distutils   import sysconfig
from swig_config import configure_swig_env, get_status_output

# Make sure that we have a good scons-version
EnsureSConsVersion(0, 98, 5)

# Create a SCons Environment based on the main os environment
env = Environment(ENV=os.environ)

# UFC version number
ufc_file = open("src/ufc/ufc.h","r").read()
major = int(re.findall("UFC_VERSION_MAJOR ([0-9])",ufc_file)[0])
minor = int(re.findall("UFC_VERSION_MINOR ([0-9])",ufc_file)[0])
maintenance = int(re.findall("UFC_VERSION_MAINTENANCE ([0-9])",ufc_file)[0])

# Build the commandline options for SCons:
if env["PLATFORM"].startswith("win"):
    default_prefix = r"c:\local"
elif env["PLATFORM"] == "darwin":
    default_prefix = join(sep,"sw")
else:
    default_prefix = join(sep,"usr","local")

if env["PLATFORM"].startswith("win"):
    default_python_dir = os.path.join("$prefix", "Lib", "site-packages")
elif env["PLATFORM"] == "darwin":
    default_python_dir = os.path.join("$prefix", "lib", "python" + sysconfig.get_python_version(),"site-packages")
else:
    default_python_dir = sysconfig.get_python_lib(prefix="$prefix",plat_specific=True)

options = [
    # configurable options for installation:
    PathVariable("prefix", "Installation prefix", default_prefix, PathVariable.PathAccept),
    PathVariable("includeDir", "ufc.h installation directory",
               join("$prefix","include"), PathVariable.PathAccept),
    PathVariable("pythonModuleDir", "Python module installation directory", 
               default_python_dir, PathVariable.PathAccept),
    BoolVariable("enablePyUFC", "Compile and install the python extension module", "Yes"),
    PathVariable("pythonExtDir", "Python extension module installation directory",
               default_python_dir, PathVariable.PathAccept),
    PathVariable("boostDir", "Specify path to Boost", None),
    PathVariable("pkgConfDir", "Directory for installation of pkg-config files",
               join("$prefix","lib","pkgconfig"), PathVariable.PathAccept),
    BoolVariable("cleanOldUFC", "Clean any old installed UFC modules", "No"),
    BoolVariable("cacheOptions", "Cache command-line options for later invocations", "Yes"),
    PathVariable("DESTDIR", "Prepend DESTDIR to each installed target file",
               None, PathVariable.PathAccept),
    ]

# Set the options using any cached options
cache_file = "options.cache"
opts = Variables(cache_file, args=ARGUMENTS.copy())
opts.AddVariables(*options)
opts.Update(env)
cache_options = env.get("cacheOptions", False)
DESTDIR = env.get("DESTDIR")
if cache_options:
    del env["cacheOptions"] # Don't store this value
    if DESTDIR:
        del env["DESTDIR"]
    opts.Save(cache_file, env)
    # Restore cacheOptions
    env["cacheOptions"] = cache_options
    if DESTDIR:
        env["DESTDIR"] = DESTDIR

# Start building the message presented at the end of a simulation
end_message = "\n"

# Check for old ufc installation
old_ufc_modules = []
for p in sys.path:
    if isfile(join(p,"ufc","__init__.py")):
        old_ufc_modules.append(join(p,"ufc"))

# If not cleaning
if not env.GetOption("clean"):
    # Notify the user about that options from scons/options.cache are being used:
    if isfile(cache_file) and getsize(cache_file):
        print "Using options from options.cache"
    
    # Append end_message if old ufc module excists
    if old_ufc_modules:
        end_message +=  """
---------------------------------------------------------
*** Warning: Old ufc module

%s
  
still excists in installation path.
Try remove these files with:

    scons -c cleanOldUFC=Yes

Note that you may need to be root.
"""%("\n".join("    " + m for m in old_ufc_modules))

# Generate pkgconfig file
pkg_config_file = "ufc-%d.pc" % major
file = open(pkg_config_file, "w")
file.write("Name: UFC\n")
file.write("Version: %d.%d.%d\n" % (major, minor, maintenance))
file.write("Description: Unified Form-assembly Code\n")
file.write("Cflags: -I%s\n" % \
           repr(normpath(env.subst(env["includeDir"])))[1:-1])
file.close()

if env.get("DESTDIR"):
    install_prefix = os.path.join("$DESTDIR", "$prefix")
    tgts_dir = ["includeDir", "pythonModuleDir", "pythonExtDir", "pkgConfDir"]
    for tgt_dir in tgts_dir:
        env[tgt_dir] = env[tgt_dir].replace("$prefix", install_prefix)

# If necessary, replace site-packages with dist-packages when prefix is
# either /usr or /usr/local (hack for Python 2.6 on Debian/Ubuntu)
if env.subst("$prefix").rstrip("/") in ("/usr", "/usr/local") and \
       "dist-packages" in sysconfig.get_python_lib():
    for tgt_dir in ["pythonModuleDir", "pythonExtDir"]:
        env[tgt_dir] = env[tgt_dir].replace("site-packages", "dist-packages")
               
# Now generate the help text
env.Help(opts.GenerateHelpText(env))

# Set up installation targets
ufc_basename = join("src", "ufc", "ufc")
env.Install(env["pkgConfDir"],File(pkg_config_file))
env.Install(env["includeDir"],File(ufc_basename+".h"))
env.Install(join(env["pythonModuleDir"],"ufc_utils"),
            [File(f) for f in glob.glob(join("src","utils","python","ufc","*.py") )])

targets = [env["pkgConfDir"],env["pythonModuleDir"],env["includeDir"]]

# If compiling the extension module
if env["enablePyUFC"]:
    swig_env, message = configure_swig_env(env.Clone())
    end_message += message
    if swig_env["enablePyUFC"]:
        ufc_wrap, ufc_py = swig_env.CXXFile(target=ufc_basename,
                                            source=[ufc_basename+".i"])
        ufc_so = swig_env.SharedLibrary(target=ufc_basename, source=ufc_wrap)[0]
        
        # A SCons bug workaround. Fixed in newer SCons versions
        ufc_py = File(join(dirname(ufc_basename),basename(str(ufc_py))))

        # Set up installation targets
        env.Install(join(env["includeDir"], "swig"),File(ufc_basename+".i"))
        env.Install(env["pythonExtDir"],[ufc_py,ufc_so])
        targets.append(env["pythonExtDir"])

# Set the alias for install
env.Alias("install", targets)

# Create installation target folders if they don't exists:
if 'install' in COMMAND_LINE_TARGETS:
    for target_dir in [env.subst(d) for d in targets]:
        if not os.path.isdir(target_dir):
            os.makedirs(target_dir)

# If the user are cleaning remove any old ufc python modules
#if env.GetOption("clean") and isdir(join(env.subst(env["pythonModuleDir"]),"ufc")):
if old_ufc_modules and env["cleanOldUFC"]:
    Clean(env["pythonModuleDir"],old_ufc_modules)

if not env.GetOption("clean"):
    import atexit
    if 'install' not in COMMAND_LINE_TARGETS:
        end_message += """
---------------------------------------------------------
Compilation of UFC finished. Now run

    scons install

to install UFC on your system. Note that you may need
to be root in order to install. To specify an alternative
installation directory, run

    scons install prefix=<path>

---------------------------------------------------------
"""
    def out():
        from SCons.Script import GetBuildFailures
        build_failures = GetBuildFailures()
        if build_failures:
            for bf in build_failures:
                print "%s failed: %s" % (bf.node, bf.errstr)
            return
        if not env.GetOption('clean') and not env.GetOption('help'):
            print end_message
    atexit.register(out)

=== debian/changelog ===
ufc (1.4.1-1) unstable; urgency=low

  * New upstream release.
  * Fix Vcs fields in debian/control.
  * Switch to dpkg-source 3.0 (quilt) format.
  * Bump Standards-Version to 3.9.0 (no changes needed).

 -- Johannes Ring <johannr@simula.no>  Thu, 01 Jul 2010 13:00:07 +0200

ufc (1.4.0-2) unstable; urgency=low

  * Package moved from pkg-scicomp to Debian Science.
  * Build for Python >= 2.5.

 -- Johannes Ring <johannr@simula.no>  Tue, 20 Apr 2010 09:46:04 +0200

ufc (1.4.0-1) unstable; urgency=low

  * New upstream release.
  * debian/control: Bump Standards-Version to 3.8.4 (no changes
    needed). 

 -- Johannes Ring <johannr@simula.no>  Tue, 02 Feb 2010 15:49:37 +0100

ufc (1.2.0-2) unstable; urgency=low

  * debian/watch, debian/copyright: Update download URLs.
  * debian/python-ufc.install: Allow both site-packages and
    dist-packages.

 -- Johannes Ring <johannr@simula.no>  Mon, 04 Jan 2010 15:20:14 +0100

ufc (1.2.0-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    - Add DM-Upload-Allowed: yes.
    - Bump debhelper version to 7.
    - Bump Standards-Version to 3.8.3 (no changes needed).

 -- Johannes Ring <johannr@simula.no>  Thu, 24 Sep 2009 11:15:25 +0200

ufc (1.1.2-1) unstable; urgency=low

  * Initial release (Closes: #503072)

 -- Johannes Ring <johannr@simula.no>  Mon, 15 Sep 2008 12:43:05 +0200

=== debian/control ===
Source: ufc
Section: math
Priority: extra
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>, Johannes Ring <johannr@simula.no>
Build-Depends: cdbs (>= 0.4.49), debhelper (>= 7), python-all-dev, 
 python-central (>= 0.6.0), scons, swig (>= 1.3.35), libboost-dev
Standards-Version: 3.9.0
XS-Python-Version: >= 2.5
Homepage: http://www.fenics.org/wiki/UFC
DM-Upload-Allowed: yes
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/fenics/ufc/trunk
Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/fenics/ufc/trunk/

Package: ufc
Section: devel
Architecture: all
Depends: ${misc:Depends}
Suggests: ufc-doc
Description: unified code generation interface for form-compilers
 UFC (Unified Form-assembly Code) is a unified framework for finite element
 assembly. More precisely, it defines a fixed interface for communicating low
 level routines (functions) for evaluating and assembling finite element
 variational forms. The UFC interface consists of a single header file ufc.h
 that specifies a C++ interface that must be implemented by code that complies
 with the UFC specification. Examples of form compilers that support the UFC
 interface are FFC and SyFi.

Package: python-ufc
Section: python
Architecture: any
XB-Python-Version: ${python:Versions}
Depends: ufc (= ${source:Version}), ${python:Depends}, ${shlibs:Depends}, 
 ${misc:Depends}
Description: unified code generation interface for form-compilers
 UFC (Unified Form-assembly Code) is a unified framework for finite element
 assembly. More precisely, it defines a fixed interface for communicating low
 level routines (functions) for evaluating and assembling finite element
 variational forms. The UFC interface consists of a single header file ufc.h
 that specifies a C++ interface that must be implemented by code that complies
 with the UFC specification. Examples of form compilers that support the UFC
 interface are FFC and SyFi.
 .
 This package contains the Python bindings for UFC.

Package: ufc-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: ufc, python-ufc
Description: unified code generation interface for form-compilers
 UFC (Unified Form-assembly Code) is a unified framework for finite element
 assembly. More precisely, it defines a fixed interface for communicating low
 level routines (functions) for evaluating and assembling finite element
 variational forms. The UFC interface consists of a single header file ufc.h
 that specifies a C++ interface that must be implemented by code that complies
 with the UFC specification. Examples of form compilers that support the UFC
 interface are FFC and SyFi.
 .
 This package contains documentation for UFC.

=== debian/rules ===
#!/usr/bin/make -f

include debian/cdbs/1/class/scons.mk
include /usr/share/cdbs/1/rules/debhelper.mk

DEB_COMPRESS_EXCLUDE := .pdf
DEB_INSTALL_DOCS_ALL += README AUTHORS TODO
DEB_SCONS_OPTIONS = prefix=/usr
DEB_DH_INSTALL_SOURCEDIR = debian/tmp
DEB_SCONS_INSTALL_OPTIONS = DESTDIR=$(CURDIR)/debian/tmp
USCAN_DESTDIR := $(CURDIR)
SCONS = `which scons`
PYVERSIONS = $(shell pyversions --requested debian/control)

clean::
	rm -f config.log
	rm -f options.cache
	rm -f src/ufc/_ufc.so
	rm -f src/ufc/ufc.py
	rm -f src/ufc/ufc_wrap.cc
	rm -f src/ufc/ufc_wrap.cxx
	rm -f src/ufc/ufc_wrap.os
	rm -f swig_config.pyc
	rm -f ufc-1.pc
	-rm -rf $(addprefix build-, $(PYVERSIONS))
	-rm -rf $(addprefix build-stamp-, $(PYVERSIONS))
	-rm -rf $(addprefix install-stamp-, $(PYVERSIONS))

common-build-arch:: $(addprefix build-stamp-, $(PYVERSIONS))
build-stamp-%:
	mkdir build-$*
	cp -r `ls | grep -vE '(build-|stamp|debian)'` build-$*
	cd build-$* && `which $*` $(SCONS) prefix=/usr
	touch $@

common-install-arch:: $(addprefix install-stamp-, $(PYVERSIONS))
install-stamp-%:
	cd build-$* && `which $*` $(SCONS) install DESTDIR=$(CURDIR)/debian/tmp
	touch $@

binary-install/python-ufc::
	dh_pycentral -p$(cdbs_curpkg)

get-orig-source:
	uscan --force-download --verbose --destdir $(USCAN_DESTDIR)

=== debian/watch ===
version=3
http://launchpad.net/ufc/+download http://launchpad.net/ufc/.*/ufc-(.*)\.tar\.gz

## ufc 2.0.0

=== CMakeLists.txt ===
# Top level CMakeLists.txt file for UFC

#------------------------------------------------------------------------------

# Require CMake 2.8
cmake_minimum_required(VERSION 2.8)

#------------------------------------------------------------------------------
project(UFC)

# Set special link option, see `cmake --help-policy CMP0003`
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif()

# Set verbose output while testing CMake
#set(CMAKE_VERBOSE_MAKEFILE 1)

# Set location of our FindFoo.cmake modules
set(UFC_CMAKE_DIR "${UFC_SOURCE_DIR}/cmake" CACHE INTERNAL "")

#------------------------------------------------------------------------------
# Set UFC version number

set(UFC_VERSION_MAJOR "1")
set(UFC_VERSION_MINOR "4")
set(UFC_VERSION_MICRO "1")
set(UFC_VERSION_STRING "${UFC_VERSION_MAJOR}.${UFC_VERSION_MINOR}.${UFC_VERSION_MICRO}")

#------------------------------------------------------------------------------
# Options

option(UFC_ENABLE_PYTHON "Enable Python extensions." ON)

#------------------------------------------------------------------------------
# Run tests to find required packages

find_package(PythonInterp QUIET)
find_package(PythonLibs QUIET)
find_package(SWIG QUIET)
include(UseSWIG)

# Look for Boost (shared_ptr support for Python wrappers)
set(Boost_ADDITIONAL_VERSIONS 1.43 1.43.0)
set(BOOST_ROOT $ENV{BOOST_DIR})
find_package(Boost 1.36 QUIET)

#------------------------------------------------------------------------------
# Get installation path for Python modules

# Get Python module path from distutils
if (PYTHONINTERP_FOUND)
  execute_process(
    COMMAND ${PYTHON_EXECUTABLE} -c "import sys, distutils.sysconfig; sys.stdout.write(distutils.sysconfig.get_python_lib(plat_specific=True, prefix='${CMAKE_INSTALL_PREFIX}'))"
    OUTPUT_VARIABLE PYTHON_INSTALL_PATH
    )

  # Set Python installation path
  set(UFC_INSTALL_PYTHON_MODULE_DIR ${PYTHON_INSTALL_PATH})
  set(UFC_INSTALL_PYTHON_EXT_DIR ${PYTHON_INSTALL_PATH})
endif (PYTHONINTERP_FOUND)

#------------------------------------------------------------------------------
# Target names and installation directories

# Set UFC install sub-directories
set(UFC_LIB_DIR "lib")
set(UFC_INCLUDE_DIR "include")
set(UFC_PKGCONFIG_DIR "lib/pkgconfig")
set(UFC_SHARE_DIR "share")
set(UFC_MAN_DIR "share/man")
set(UFC_CMAKE_CONFIG_DIR "share/ufc")

#------------------------------------------------------------------------------
# Install ufc.h

set(UFC_H src/ufc/ufc.h)
install(FILES ${UFC_H} DESTINATION ${UFC_INCLUDE_DIR} COMPONENT Development)

#------------------------------------------------------------------------------
# Build SWIG extension and install

if (UFC_ENABLE_PYTHON AND SWIG_FOUND AND Boost_FOUND)

  # Default to release build (can be overridden by user)
  if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING
      "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
  endif()

  # Make build directory for SWIG-generated C++ file
  FILE(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/src/ufc")

  # Include directories
  include_directories(${UFC_SOURCE_DIR}/src/ufc ${Boost_INCLUDE_DIRS} ${PYTHON_INCLUDE_DIRS})

  # Set module name
  set(SWIG_MODULE_NAME ufc)

  # SWIG flags
  set(CMAKE_SWIG_FLAGS -module ${SWIG_MODULE_NAME})

  # SWIG sources
  set(SWIG_SOURCES src/ufc/ufc.i)
  set(SWIG_MODULE_${SWIG_MODULE_NAME}_EXTRA_DEPS ${UFC_H})
  set_source_files_properties(${SWIG_SOURCES} PROPERTIES CPLUSPLUS ON)
  swig_add_module(${SWIG_MODULE_NAME} python ${SWIG_SOURCES})

  # Is this required?
  swig_link_libraries(ufc ${PYTHON_LIBRARIES})
  get_target_property(SWIG_MODULE_LOCATION ${SWIG_MODULE_ufc_REAL_NAME} LOCATION)
  message("SWIG_MODULE_LOCATION ${SWIG_MODULE_LOCATION}")

  # Install the swig file
  install(FILES src/ufc/ufc.i
    DESTINATION ${UFC_INCLUDE_DIR}/swig
    COMPONENT Development
    )

  # Install _ufc.so and ufc.py
  install(FILES
    ${SWIG_MODULE_LOCATION}
    ${CMAKE_CURRENT_BINARY_DIR}/ufc.py src/ufc/__init__.py
    DESTINATION ${UFC_INSTALL_PYTHON_MODULE_DIR}/ufc
    COMPONENT Development
    )

endif()

#------------------------------------------------------------------------------
# Install Python utils (ufc_utils)

install(DIRECTORY
  src/utils/python/ufc_utils
  DESTINATION ${UFC_INSTALL_PYTHON_MODULE_DIR}
  USE_SOURCE_PERMISSIONS
  COMPONENT Runtime
  )

#------------------------------------------------------------------------------
# Generate ufc-config.cmake file

configure_file(${UFC_CMAKE_DIR}/ufc-config.cmake.in ufc-config.cmake @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ufc-config.cmake
  DESTINATION ${CMAKE_INSTALL_PREFIX}/${UFC_CMAKE_CONFIG_DIR}
  COMPONENT Development
  )

#------------------------------------------------------------------------------
# Generate pkg-config config file (ufc-1.pc)

configure_file(${UFC_CMAKE_DIR}/ufc-1.pc.in ufc-1.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ufc-1.pc
  DESTINATION ${CMAKE_INSTALL_PREFIX}/${UFC_PKGCONFIG_DIR}
  COMPONENT Development
  )

#------------------------------------------------------------------------------

=== debian/changelog ===
ufc (2.0.0-1) unstable; urgency=low

  * New upstream release.
  * debian/copyright: Minor fix.
  * Update Homepage field in debian/control.

 -- Johannes Ring <johannr@simula.no>  Wed, 23 Feb 2011 19:39:27 +0100

ufc (1.4.2-1) unstable; urgency=low

  * New upstream release.
  * Switch to CMake CDBS class.
    - Remove CDBS files for SCons and remove note in debian/copyright.
    - Replace scons with cmake in Build-Depends in debian/control.
    - Add UFC CMake config file to debian/ufc.install.
  * Bump Standards-Version to 3.9.1 (no changes needed).

 -- Johannes Ring <johannr@simula.no>  Thu, 02 Sep 2010 08:25:44 +0200

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Christophe Prud'homme <prudhomm@debian.org>, Johannes Ring <johannr@simula.no>
 Build-Depends: cdbs (>= 0.4.49), debhelper (>= 7), python-all-dev, 
- python-central (>= 0.6.0), scons, swig (>= 1.3.35), libboost-dev
-Standards-Version: 3.9.0
+ python-central (>= 0.6.0), cmake (>= 2.8.0), swig (>= 1.3.35), libboost-dev
+Standards-Version: 3.9.1
 XS-Python-Version: >= 2.5
-Homepage: http://www.fenics.org/wiki/UFC
+Homepage: http://www.fenicsproject.org
 DM-Upload-Allowed: yes
 Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/fenics/ufc/trunk
 Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/fenics/ufc/trunk/

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_COMPRESS_EXCLUDE := .pdf
DEB_INSTALL_DOCS_ALL += README AUTHORS TODO
USCAN_DESTDIR := $(CURDIR)

binary-install/python-ufc::
	dh_pycentral -p$(cdbs_curpkg)

get-orig-source:
	uscan --force-download --verbose --destdir $(USCAN_DESTDIR)

## ufc 2.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,7 @@
 
 # Set location of our FindFoo.cmake modules
 set(UFC_CMAKE_DIR "${UFC_SOURCE_DIR}/cmake" CACHE INTERNAL "")
+set(CMAKE_MODULE_PATH "${UFC_CMAKE_DIR}/modules")
 
 #------------------------------------------------------------------------------
 # Set UFC version number
@@ -37,6 +38,12 @@
 
 find_package(PythonInterp QUIET)
 find_package(PythonLibs QUIET)
+
+# This is to help pick up swig on Debian/Ubuntu. It can be removed when
+# Debian/Ubuntu change swig2.0 -> swig
+find_program(SWIG_EXECUTABLE swig2.0)
+
+# Find SWIG
 find_package(SWIG QUIET)
 include(UseSWIG)
 
@@ -81,6 +88,11 @@
 # Build SWIG extension and install
 
 if (UFC_ENABLE_PYTHON AND SWIG_FOUND AND Boost_FOUND)
+
+  # Check SWIG version
+  if (${SWIG_VERSION} LESS 2.0)
+      message(ERROR " UFC requires SWIG version 2.0 or greater. You have version ${SWIG_VERSION}. Set UFC_ENABLE_PYTHON to False or install correct SWIG version.")
+    endif()
 
   # Default to release build (can be overridden by user)
   if (NOT CMAKE_BUILD_TYPE)

=== debian/changelog ===
ufc (2.0.1-1) unstable; urgency=low

  * New upstream release. This release moves to SWIG version >= 2.0 and
    fixes a const interface bug.
  * debian/control:
    - Replace swig with swig2.0 in Build-Depends.
    - Bump Standards-Version to 3.9.2 (no changes needed).
  * debian/rules: Set SWIG_EXECUTABLE to /usr/bin/swig2.0.

 -- Johannes Ring <johannr@simula.no>  Mon, 16 May 2011 23:11:41 +0200

ufc (2.0.0-2) unstable; urgency=low

  * Move from python-central to dh_python2 (closes: #617136).
    - Remove python-central from Build-Depends.
    - Bump minimum required python-all-dev package version to 2.6.6-3~.
    - Remove XB-Python-Version line.
    - Bump minimum required cdbs version to 0.4.90~.
    - Replace XS-Python-Version with X-Python-Version.
    - Replace call to dh_pycentral with dh_python2 in debian/rules.
  * Build for all supported Python versions.
  * Update short description for binary packages python-ufc and ufc-doc.
  * Add doc-base file for binary package ufc-doc.

 -- Johannes Ring <johannr@simula.no>  Thu, 14 Apr 2011 15:21:16 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,14 @@
 Priority: extra
 Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Christophe Prud'homme <prudhomm@debian.org>, Johannes Ring <johannr@simula.no>
-Build-Depends: cdbs (>= 0.4.49), debhelper (>= 7), python-all-dev, 
- python-central (>= 0.6.0), cmake (>= 2.8.0), swig (>= 1.3.35), libboost-dev
-Standards-Version: 3.9.1
-XS-Python-Version: >= 2.5
+Build-Depends: cdbs (>= 0.4.90~),
+ debhelper (>= 7),
+ python-all-dev (>= 2.6.6-3~),
+ cmake (>= 2.8.0),
+ swig2.0,
+ libboost-dev
+Standards-Version: 3.9.2
+X-Python-Version: >= 2.5
 Homepage: http://www.fenicsproject.org
 DM-Upload-Allowed: yes
 Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/fenics/ufc/trunk
@@ -29,10 +33,11 @@
 Package: python-ufc
 Section: python
 Architecture: any
-XB-Python-Version: ${python:Versions}
-Depends: ufc (= ${source:Version}), ${python:Depends}, ${shlibs:Depends}, 
+Depends: ufc (= ${source:Version}),
+ ${python:Depends},
+ ${shlibs:Depends}, 
  ${misc:Depends}
-Description: unified code generation interface for form-compilers
+Description: Python utilities (templates) for generating UFC code
  UFC (Unified Form-assembly Code) is a unified framework for finite element
  assembly. More precisely, it defines a fixed interface for communicating low
  level routines (functions) for evaluating and assembling finite element
@@ -41,14 +46,14 @@
  with the UFC specification. Examples of form compilers that support the UFC
  interface are FFC and SyFi.
  .
- This package contains the Python bindings for UFC.
+ This package contains Python utilities for generating UFC code.
 
 Package: ufc-doc
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}
 Suggests: ufc, python-ufc
-Description: unified code generation interface for form-compilers
+Description: documentation for UFC
  UFC (Unified Form-assembly Code) is a unified framework for finite element
  assembly. More precisely, it defines a fixed interface for communicating low
  level routines (functions) for evaluating and assembling finite element

## ufc 2.0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,16 @@
 # Top level CMakeLists.txt file for UFC
-
-#------------------------------------------------------------------------------
 
 # Require CMake 2.8
 cmake_minimum_required(VERSION 2.8)
 
 #------------------------------------------------------------------------------
+# Set project name and version number
+
 project(UFC)
+set(UFC_VERSION_MAJOR "2")
+set(UFC_VERSION_MINOR "0")
+set(UFC_VERSION_MICRO "3")
+set(UFC_VERSION_STRING "${UFC_VERSION_MAJOR}.${UFC_VERSION_MINOR}.${UFC_VERSION_MICRO}")
 
 # Set special link option, see `cmake --help-policy CMP0003`
 if(COMMAND cmake_policy)
@@ -19,14 +23,6 @@
 # Set location of our FindFoo.cmake modules
 set(UFC_CMAKE_DIR "${UFC_SOURCE_DIR}/cmake" CACHE INTERNAL "")
 set(CMAKE_MODULE_PATH "${UFC_CMAKE_DIR}/modules")
-
-#------------------------------------------------------------------------------
-# Set UFC version number
-
-set(UFC_VERSION_MAJOR "1")
-set(UFC_VERSION_MINOR "4")
-set(UFC_VERSION_MICRO "1")
-set(UFC_VERSION_STRING "${UFC_VERSION_MAJOR}.${UFC_VERSION_MINOR}.${UFC_VERSION_MICRO}")
 
 #------------------------------------------------------------------------------
 # Options
@@ -61,10 +57,19 @@
     COMMAND ${PYTHON_EXECUTABLE} -c "import sys, distutils.sysconfig; sys.stdout.write(distutils.sysconfig.get_python_lib(plat_specific=True, prefix='${CMAKE_INSTALL_PREFIX}'))"
     OUTPUT_VARIABLE PYTHON_INSTALL_PATH
     )
+  # Strip off CMAKE_INSTALL_PREFIX (is added later by CMake)
+  string(REGEX REPLACE "${CMAKE_INSTALL_PREFIX}(/|\\\\)([^ ]*)" "\\2"
+    PYTHON_INSTALL_PATH "${PYTHON_INSTALL_PATH}")
 
   # Set Python installation path
-  set(UFC_INSTALL_PYTHON_MODULE_DIR ${PYTHON_INSTALL_PATH})
-  set(UFC_INSTALL_PYTHON_EXT_DIR ${PYTHON_INSTALL_PATH})
+  if (NOT DEFINED UFC_INSTALL_PYTHON_MODULE_DIR)
+    set(UFC_INSTALL_PYTHON_MODULE_DIR ${PYTHON_INSTALL_PATH}
+      CACHE PATH "Python module installation directory.")
+  endif()
+  if (NOT DEFINED UFC_INSTALL_PYTHON_EXT_DIR)
+    set(UFC_INSTALL_PYTHON_EXT_DIR ${PYTHON_INSTALL_PATH}
+      CACHE PATH "Python extension module installation directory.")
+  endif()
 endif (PYTHONINTERP_FOUND)
 
 #------------------------------------------------------------------------------
@@ -150,11 +155,21 @@
   )
 
 #------------------------------------------------------------------------------
-# Generate ufc-config.cmake file
+# Generate UFCConfig.cmake file
 
-configure_file(${UFC_CMAKE_DIR}/ufc-config.cmake.in ufc-config.cmake @ONLY)
-install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ufc-config.cmake
-  DESTINATION ${CMAKE_INSTALL_PREFIX}/${UFC_CMAKE_CONFIG_DIR}
+configure_file(${UFC_CMAKE_DIR}/UFCConfig.cmake.in UFCConfig.cmake @ONLY)
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/UFCConfig.cmake
+  DESTINATION ${UFC_CMAKE_CONFIG_DIR}
+  COMPONENT Development
+  )
+
+#------------------------------------------------------------------------------
+# Generate UFCConfigVersion.cmake file
+
+configure_file(${UFC_CMAKE_DIR}/UFCConfigVersion.cmake.in
+  UFCConfigVersion.cmake @ONLY)
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/UFCConfigVersion.cmake
+  DESTINATION ${UFC_CMAKE_CONFIG_DIR}
   COMPONENT Development
   )
 
@@ -163,7 +178,7 @@
 
 configure_file(${UFC_CMAKE_DIR}/ufc-1.pc.in ufc-1.pc @ONLY)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ufc-1.pc
-  DESTINATION ${CMAKE_INSTALL_PREFIX}/${UFC_PKGCONFIG_DIR}
+  DESTINATION ${UFC_PKGCONFIG_DIR}
   COMPONENT Development
   )

=== debian/changelog ===
ufc (2.0.3-1) unstable; urgency=low

  * New upstream release.
  * debian/ufc.install: Install all CMake files.

 -- Johannes Ring <johannr@simula.no>  Wed, 26 Oct 2011 17:36:41 +0200

ufc (2.0.2-1) unstable; urgency=low

  * New upstream release.

 -- Johannes Ring <johannr@simula.no>  Mon, 15 Aug 2011 14:31:39 +0200

## ufc 2.0.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 project(UFC)
 set(UFC_VERSION_MAJOR "2")
 set(UFC_VERSION_MINOR "0")
-set(UFC_VERSION_MICRO "3")
+set(UFC_VERSION_MICRO "5")
 set(UFC_VERSION_STRING "${UFC_VERSION_MAJOR}.${UFC_VERSION_MINOR}.${UFC_VERSION_MICRO}")
 
 # Set special link option, see `cmake --help-policy CMP0003`

=== debian/changelog ===
ufc (2.0.5-3) unstable; urgency=low

  * debian/control: Bump Standards-Version to 3.9.3.

 -- Johannes Ring <johannr@simula.no>  Thu, 28 Jun 2012 14:27:22 +0200

ufc (2.0.5-2) unstable; urgency=low

  * debian/watch: Replace http with https in URL.
  * Add patch to fix problems with SWIG 2.0.5.

 -- Johannes Ring <johannr@simula.no>  Fri, 11 May 2012 12:24:13 +0200

ufc (2.0.5-1) unstable; urgency=low

  * New upstream release.

 -- Johannes Ring <johannr@simula.no>  Wed, 07 Dec 2011 12:55:13 +0100

ufc (2.0.4-1) unstable; urgency=low

  * New upstream release.

 -- Johannes Ring <johannr@simula.no>  Mon, 28 Nov 2011 22:40:05 +0100

=== debian/control ===
--- 
+++ 
@@ -9,9 +9,9 @@
  cmake (>= 2.8.0),
  swig2.0,
  libboost-dev
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 X-Python-Version: >= 2.5
-Homepage: http://www.fenicsproject.org
+Homepage: http://fenicsproject.org
 DM-Upload-Allowed: yes
 Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/fenics/ufc/trunk
 Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/fenics/ufc/trunk/

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_INSTALL_DOCS_ALL += README AUTHORS TODO
DEB_CMAKE_EXTRA_FLAGS= -D SWIG_EXECUTABLE:FILEPATH=/usr/bin/swig2.0 ..
USCAN_DESTDIR := $(CURDIR)

PY_VERSIONS = $(shell pyversions --requested debian/control | tac -s' ')

install-stamp-%:
	cd $(DEB_BUILDDIR) && rm CMakeCache.txt && \
	  cmake -D PYTHON_EXECUTABLE:FILEPATH=/usr/bin/$* \
	    -D PYTHON_LIBRARY:FILEPATH=/usr/lib/lib$*.so \
	    -D PYTHON_INCLUDE_DIR:PATH=/usr/include/$* \
	    $(DEB_CMAKE_NORMAL_ARGS) $(DEB_CMAKE_EXTRA_FLAGS)
	make -C $(DEB_BUILDDIR) install DESTDIR=$(CURDIR)/debian/tmp
	touch $@

install/python-ufc:: $(addprefix install-stamp-, $(PY_VERSIONS))

binary-install/python-ufc::
	dh_python2 -p$(cdbs_curpkg)

clean::
	-rm -rf $(addprefix install-stamp-, $(PY_VERSIONS))

get-orig-source:
	uscan --force-download --verbose --destdir $(USCAN_DESTDIR)

=== debian/watch ===
version=3
https://launchpad.net/ufc/+download https://launchpad.net/ufc/.*/ufc-(.*)\.tar\.gz

## ufc 2.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,15 @@
 # Top level CMakeLists.txt file for UFC
 
-# Require CMake 2.8
-cmake_minimum_required(VERSION 2.8)
+# Require CMake 2.6
+cmake_minimum_required(VERSION 2.6)
 
 #------------------------------------------------------------------------------
 # Set project name and version number
 
 project(UFC)
 set(UFC_VERSION_MAJOR "2")
-set(UFC_VERSION_MINOR "0")
-set(UFC_VERSION_MICRO "5")
+set(UFC_VERSION_MINOR "2")
+set(UFC_VERSION_MICRO "0")
 set(UFC_VERSION_STRING "${UFC_VERSION_MAJOR}.${UFC_VERSION_MINOR}.${UFC_VERSION_MICRO}")
 
 # Set special link option, see `cmake --help-policy CMP0003`
@@ -33,11 +33,9 @@
 # Run tests to find required packages
 
 find_package(PythonInterp QUIET)
-find_package(PythonLibs QUIET)
-
-# This is to help pick up swig on Debian/Ubuntu. It can be removed when
-# Debian/Ubuntu change swig2.0 -> swig
-find_program(SWIG_EXECUTABLE swig2.0)
+
+# Find Python library corresponding to Python interpreter
+find_package(PythonLibs ${PYTHON_VERSION_STRING} EXACT QUIET)
 
 # Find SWIG
 find_package(SWIG QUIET)
@@ -53,40 +51,51 @@
 
 # Get Python module path from distutils
 if (PYTHONINTERP_FOUND)
-  execute_process(
-    COMMAND ${PYTHON_EXECUTABLE} -c "import sys, distutils.sysconfig; sys.stdout.write(distutils.sysconfig.get_python_lib(plat_specific=True, prefix='${CMAKE_INSTALL_PREFIX}'))"
-    OUTPUT_VARIABLE PYTHON_INSTALL_PATH
-    )
-  # Strip off CMAKE_INSTALL_PREFIX (is added later by CMake)
-  string(REGEX REPLACE "${CMAKE_INSTALL_PREFIX}(/|\\\\)([^ ]*)" "\\2"
-    PYTHON_INSTALL_PATH "${PYTHON_INSTALL_PATH}")
-
-  # Set Python installation path
+
+  if (NOT DEFINED UFC_INSTALL_PYTHON_EXT_DIR)
+    # Get path for platform-dependent Python modules (since we install a binary libary)
+    execute_process(
+      COMMAND ${PYTHON_EXECUTABLE} -c "import sys, distutils.sysconfig; sys.stdout.write(distutils.sysconfig.get_python_lib(plat_specific=True, prefix='${CMAKE_INSTALL_PREFIX}'))"
+      OUTPUT_VARIABLE UFC_INSTALL_PYTHON_EXT_DIR
+      )
+    # Strip off CMAKE_INSTALL_PREFIX (is added later by CMake)
+    string(REGEX REPLACE "${CMAKE_INSTALL_PREFIX}(/|\\\\)([^ ]*)" "\\2"
+      UFC_INSTALL_PYTHON_EXT_DIR "${UFC_INSTALL_PYTHON_EXT_DIR}")
+    set(UFC_INSTALL_PYTHON_EXT_DIR ${UFC_INSTALL_PYTHON_EXT_DIR}
+      CACHE PATH "Python extension module installation directory.")
+  endif()
+
   if (NOT DEFINED UFC_INSTALL_PYTHON_MODULE_DIR)
-    set(UFC_INSTALL_PYTHON_MODULE_DIR ${PYTHON_INSTALL_PATH}
+    # Get path for pure Python modules
+    execute_process(
+      COMMAND ${PYTHON_EXECUTABLE} -c "import sys, distutils.sysconfig; sys.stdout.write(distutils.sysconfig.get_python_lib(plat_specific=False, prefix='${CMAKE_INSTALL_PREFIX}'))"
+      OUTPUT_VARIABLE UFC_INSTALL_PYTHON_MODULE_DIR
+      )
+    # Strip off CMAKE_INSTALL_PREFIX (is added later by CMake)
+    string(REGEX REPLACE "${CMAKE_INSTALL_PREFIX}(/|\\\\)([^ ]*)" "\\2"
+      UFC_INSTALL_PYTHON_MODULE_DIR "${UFC_INSTALL_PYTHON_MODULE_DIR}")
+    set(UFC_INSTALL_PYTHON_MODULE_DIR ${UFC_INSTALL_PYTHON_MODULE_DIR}
       CACHE PATH "Python module installation directory.")
   endif()
-  if (NOT DEFINED UFC_INSTALL_PYTHON_EXT_DIR)
-    set(UFC_INSTALL_PYTHON_EXT_DIR ${PYTHON_INSTALL_PATH}
-      CACHE PATH "Python extension module installation directory.")
-  endif()
 endif (PYTHONINTERP_FOUND)
 
 #------------------------------------------------------------------------------
 # Target names and installation directories
 
 # Set UFC install sub-directories
-set(UFC_LIB_DIR "lib")
-set(UFC_INCLUDE_DIR "include")
-set(UFC_PKGCONFIG_DIR "lib/pkgconfig")
-set(UFC_SHARE_DIR "share")
-set(UFC_MAN_DIR "share/man")
-set(UFC_CMAKE_CONFIG_DIR "share/ufc")
+if (LIB_INSTALL_DIR)
+  set(UFC_LIB_DIR "${LIB_INSTALL_DIR}" CACHE PATH "Library installation directory.")
+else()
+  set(UFC_LIB_DIR "lib" CACHE PATH "Library installation directory.")
+endif()
+set(UFC_INCLUDE_DIR "include" CACHE PATH "C/C++ header installation directory.")
+set(UFC_PKGCONFIG_DIR "${UFC_LIB_DIR}/pkgconfig" CACHE PATH "pkg-config file installation directory.")
+set(UFC_CMAKE_CONFIG_DIR "share/ufc" CACHE PATH "CMake configuration file directory.")
 
 #------------------------------------------------------------------------------
 # Install ufc.h
 
-set(UFC_H src/ufc/ufc.h)
+set(UFC_H src/ufc/ufc.h src/ufc/ufc_geometry.h)
 install(FILES ${UFC_H} DESTINATION ${UFC_INCLUDE_DIR} COMPONENT Development)
 
 #------------------------------------------------------------------------------
@@ -108,6 +117,11 @@
   # Make build directory for SWIG-generated C++ file
   FILE(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/src/ufc")
 
+  # In CMake 2.6 PYTHON_INCLUDE_DIRS was named PYTHON_INCLUDE_PATH
+  if (NOT DEFINED PYTHON_INCLUDE_DIRS)
+    set(PYTHON_INCLUDE_DIRS ${PYTHON_INCLUDE_PATH})
+  endif()
+
   # Include directories
   include_directories(${UFC_SOURCE_DIR}/src/ufc ${Boost_INCLUDE_DIRS} ${PYTHON_INCLUDE_DIRS})
 
@@ -115,7 +129,21 @@
   set(SWIG_MODULE_NAME ufc)
 
   # SWIG flags
-  set(CMAKE_SWIG_FLAGS -module ${SWIG_MODULE_NAME})
+  set(CMAKE_SWIG_FLAGS
+    -module ${SWIG_MODULE_NAME}
+    -shadow
+    -modern
+    -modernargs
+    -fastdispatch
+    -fvirtual
+    -nosafecstrings
+    -noproxydel
+    -fastproxy
+    -fastinit
+    -fastunpack
+    -fastquery
+    -nobuildnone
+    )
 
   # SWIG sources
   set(SWIG_SOURCES src/ufc/ufc.i)
@@ -138,7 +166,7 @@
   install(FILES
     ${SWIG_MODULE_LOCATION}
     ${CMAKE_CURRENT_BINARY_DIR}/ufc.py src/ufc/__init__.py
-    DESTINATION ${UFC_INSTALL_PYTHON_MODULE_DIR}/ufc
+    DESTINATION ${UFC_INSTALL_PYTHON_EXT_DIR}/ufc
     COMPONENT Development
     )
 
@@ -174,6 +202,15 @@
   )
 
 #------------------------------------------------------------------------------
+# Generate UseUFC.cmake file
+
+configure_file(${UFC_CMAKE_DIR}/UseUFC.cmake.in UseUFC.cmake @ONLY)
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/UseUFC.cmake
+  DESTINATION ${UFC_CMAKE_CONFIG_DIR}
+  COMPONENT Development
+  )
+
+#------------------------------------------------------------------------------
 # Generate pkg-config config file (ufc-1.pc)
 
 configure_file(${UFC_CMAKE_DIR}/ufc-1.pc.in ufc-1.pc @ONLY)
@@ -183,4 +220,3 @@
   )
 
 #------------------------------------------------------------------------------
-

=== debian/changelog ===
ufc (2.2.0-1) unstable; urgency=low

  * New upstream release.
  * Add usr/include/ufc_geometry.h in ufc.install.
  * debian/control:
    - Bump Standards-Version to 3.9.4.
    - Remove DM-Upload-Allowed field.
    - Bump required debhelper version in Build-Depends.
    - Replace python-all-dev with python-dev in Build-Depends.
    - Remove cdbs from Build-Depends.
    - Change Architecture from all to any for binary package ufc.
    - Update to use current canonical URI in VCS-* fields.
  * debian/compat: Bump to compatibility level 9.
  * debian/rules: Rewrite for debhelper (drop cdbs).
  * Add debian/docs.

 -- Johannes Ring <johannr@simula.no>  Wed, 26 Jun 2013 11:52:21 +0200

ufc (2.1.0-1) UNRELEASED; urgency=low

  * New upstream release.
  * Remove patches (fixed upstream).

 -- Johannes Ring <johannr@simula.no>  Wed, 09 Jan 2013	13:43:13 +0100

=== debian/control ===
--- 
+++ 
@@ -3,22 +3,20 @@
 Priority: extra
 Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Christophe Prud'homme <prudhomm@debian.org>, Johannes Ring <johannr@simula.no>
-Build-Depends: cdbs (>= 0.4.90~),
- debhelper (>= 7),
- python-all-dev (>= 2.6.6-3~),
+Build-Depends: debhelper (>= 9),
+ python-dev (>= 2.6.6-3~),
  cmake (>= 2.8.0),
  swig2.0,
  libboost-dev
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 X-Python-Version: >= 2.5
 Homepage: http://fenicsproject.org
-DM-Upload-Allowed: yes
-Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/fenics/ufc/trunk
-Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/fenics/ufc/trunk/
+Vcs-Svn: svn://anonscm.debian.org/debian-science/packages/fenics/ufc/trunk
+Vcs-Browser: http://anonscm.debian.org/viewvc/debian-science/packages/fenics/ufc/trunk/
 
 Package: ufc
 Section: devel
-Architecture: all
+Architecture: any
 Depends: ${misc:Depends}
 Suggests: ufc-doc
 Description: unified code generation interface for form-compilers
@@ -33,7 +31,7 @@
 Package: python-ufc
 Section: python
 Architecture: any
-Depends: ufc (= ${source:Version}),
+Depends: ufc (= ${binary:Version}),
  ${python:Depends},
  ${shlibs:Depends}, 
  ${misc:Depends}
